/**
 * AppController.
 * @author Alejandro Arnáiz González, deathnew[at]gmail.com
 * @author Diego Crenes Carrera, dcrenes[at]gmail.com
 */
define('controllers/appcontroller',
		['app',
		 'shared/keys',
		 'shared/urlcatalog',
		 'ember'],
		 function(Filmeet, Keys, UrlCatalog){
	console.log('Defining AppController');
	Filmeet.AppController = Ember.Controller.extend({
		newNotifications: 'a',
		goToHome: function(){
			this.transitionToRoute('app.home');
		},
		goToNewMeeting: function(){
			this.transitionToRoute('meetings.newStepOne');
		},
		goToProfile: function(){
			this.transitionToRoute('app.profile', localStorage.getItem(Keys.username));
		},
		goToMeetings: function(){
			this.transitionToRoute('meetings.index');
		},
		goToFriendsDirectory: function(){
			this.transitionToRoute('friends.directory');
		},
		goToFilmDirectory: function(){
			this.transitionToRoute('films.directory');
		},
		goToNotifications: function(){
			this.transitionToRoute('app.notifications');
		},
		checkNewNotifications: function(){
			var self = this;
			$.ajax({
				type: 'GET',
				cache: false,
				url: UrlCatalog.get('checkNewNotifications'),
				data: {'userSid': localStorage.getItem(Keys.username), 'hash': localStorage.getItem(Keys.authorizationHash)},
				dataType:'json',
				success: function(data){
					var $notificationButton = $('#notificationButton');
					if(data){
						self.set('newNotifications', 'b');
						$notificationButton.addClass('ui-btn-up-b');
						$notificationButton.removeClass('ui-btn-up-a');
					} else {
						self.set('newNotifications', 'a');
						$notificationButton.addClass('ui-btn-up-a');
						$notificationButton.removeClass('ui-btn-up-b');
					}
					$notificationButton.button();
				}
			});
		}
	});
});