/**
 * ProfileController.
 * @author Alejandro Arnáiz González, deathnew[at]gmail.com
 * @author Diego Crenes Carrera, dcrenes[at]gmail.com
 */
define('controllers/profile/profilecontroller',
		['app',
		 'ember',
		 'models/film/film'],
		 function(Filmeet){
	console.log('Defining ProfileController');
	Filmeet.AppProfileController = Ember.ObjectController.extend({
		// Properties
		/** User film library*/
		userFilmLibrary: [],
		/** Select menu content */
		selectValues: [],
		/** Selected option from the select menu */
		selectedOption: null,
		/** Got it check input*/
		checkedGotIt: false,
		// Functions
		/** Filters the search in the user's film library */
		filteredSearch: function(){
			var selectedOptionId = this.get('selectedOption').get('id');
			var gotIt = this.get('checkedGotIt');
			
			var seeWannaSee = null;
			if(selectedOptionId == 1){
				seeWannaSee = true;
			} else if(selectedOptionId == 2){
				seeWannaSee = false;
			}
			
			if(seeWannaSee != null || gotIt == true){
				this.set('userFilmLibrary', Filmeet.Film.getMyFilmsWithFilters(gotIt, seeWannaSee));
			} else {
				this.set('userFilmLibrary', Filmeet.Film.getMyFilms());
			}
		}.observes('selectedOption', 'checkedGotIt'),
		/** Goes to the film details screen */
		goToFilm: function(selectedFilm){
			this.transitionToRoute('films.oneDetails', selectedFilm.get('sid'));
		},
		/** Goes to the user personal configuration and settings */
		goToConfiguration: function(){
			this.transitionToRoute('app.configuration');
		}
	});
});