/**
 * FilmLibrary data model.
 * @author Alejandro Arnáiz González, deathnew[at]gmail.com
 * @author Diego Crenes Carrera, dcrenes[at]gmail.com
 */
define('models/filmlibrary/filmlibrary',
		['app',
		 'shared/urlcatalog',
		 'shared/keys',
		 'ember'],
		 function(Filmeet, UrlCatalog, Keys){
	/*
	 * Creating Filmeet.FilmLibrary class based on Ember.Object
	 */
	Filmeet.FilmLibrary = Ember.Object.extend({
		/** Film sid */
		filmSid: null,
		/** Owner sid */
		userSid: null,
		/** Indicates if film is at the cinema */
		gotIt: false,
		/** Film name */
		seeWannasee: null,
		/** Record date */
		recordDate: null,
		/** Updates the film information data */
		updateFilmStatus: function(){
			$.ajax({
				type: 'POST',
				cache: false,
				url: UrlCatalog.get('updateFilmStatus'),
				data: {'filmSid': this.get('filmSid'), 'gotIt': this.get('gotIt'), 'seeWannaSee': this.get('seeWannasee'), 'hash': localStorage.getItem(Keys.authorizationHash)},
				success: function(){}
			});
		}
	});
	/*
	 * Reopening class for coding static properties and functions
	 */
	Filmeet.FilmLibrary.reopenClass({
		// Functions
		getFilmLibraryUserStatus: function(filmSid, callbackSuccess){
			$.ajax({
				type: 'GET',
				cache: false,
				url: UrlCatalog.get('getFilmLibrary'),
				data: {'filmSid': filmSid, 'hash': localStorage.getItem(Keys.authorizationHash)},
				dataType:'json',
				success: callbackSuccess
			});
		},
		addToFilmLibrary: function(filmLibrary){
			$.ajax({
				type: 'POST',
				cache: false,
				url: UrlCatalog.get('addToFilmLibrary'),
				data: {'filmSid': filmLibrary.get('filmSid'), 'gotIt': filmLibrary.get('gotIt'), 'seeWannaSee': filmLibrary.get('seeWannasee'), 'hash': localStorage.getItem(Keys.authorizationHash)},
				success: function(data){
					filmLibrary.set('recordDate',data);
				}
			});
			
		}
	});
});