/**
 * Notification data model.
 * @author Alejandro Arnáiz González, deathnew[at]gmail.com
 * @author Diego Crenes Carrera, dcrenes[at]gmail.com
 */
define('models/notification/notification',
		['app',
		 'shared/urlcatalog',
		 'shared/keys',
		 'ember'],
		 function(Filmeet, UrlCatalog, Keys){
	/*
	 * Creating Filmeet.Notification class based on Ember.Object
	 */
	Filmeet.Notification = Ember.Object.extend({
		/** Notification sid */
		sid: 0,
		/** User sender sid */
		senderSid: null,
		/** User receiver sid */
		receiverSid: null,
		/** Meeting sid */
		meetingSid: null,
		/** Meeting voted */
		meetingVoted: false,
		/** Meeting Name */
		meetingName: null,
		/** Date*/
		date: null,
		/** Seen notification */
		seen: false,
		/** Mark as seen function */
		markAsSeen: function(){
			$.ajax({
				type: 'POST',
				cache: false,
				url: UrlCatalog.get('markAsSeen')+'/'+this.get('sid'),
				data: {'hash': localStorage.getItem(Keys.authorizationHash)},
				dataType:'json',
				context: this,
				success: function(){
					this.set('seen', true);
				}
			});
		}
	});
	/*
	 * Reopening class for coding static properties and functions
	 */
	Filmeet.Notification.reopenClass({
		// Functions
		getUserNotifications: function(){
			var userNotificationsList = [];
			$.ajax({
				type: 'GET',
				cache: false,
				url: UrlCatalog.get('getNotifications'),
				data: {'hash': localStorage.getItem(Keys.authorizationHash)},
				dataType:'json',
				success: function(data){
					data.forEach(function(pair){
						userNotificationsList.addObject(Filmeet.Notification.create({
							sid: pair.a.sid,
							senderSid: pair.a.senderSid,
							receiverSid: pair.a.receiverSid,
							meetingSid: pair.a.meetingSid,
							meetingVoted: pair.a.meetingVoted,
							date: pair.a.recordDate,
							seen: pair.a.seen,
							meetingName: pair.b
						}));
					});
				}
			});
			return userNotificationsList;
		}
	});
});