/**
 * User data model.
 * @author Alejandro Arnáiz González, deathnew[at]gmail.com
 * @author Diego Crenes Carrera, dcrenes[at]gmail.com
 */
define('models/user/user',
		['app',
		 'shared/urlcatalog',
		 'shared/keys',
		 'ember'],
		 function(Filmeet, UrlCatalog, Keys){
	/*
	 * Creating Filmeet.User class based on Ember.Object
	 */
	Filmeet.User = Ember.Object.extend({
		username: null,
		blocked: null
	});
	/*
	 * Reopening class for coding static properties and functions
	 */
	Filmeet.User.reopenClass({
		// Functions
		/** Gets all friends */
		getAllFriends: function(){
			var searchResult = [];
			
			$.ajax({
				type: 'GET',
				cache: false,
				url: UrlCatalog.get('getAllFriends'),
				data: {'hash': localStorage.getItem(Keys.authorizationHash)},
				dataType:'json',
				success: function(data){
					data.forEach(function(friendAndBlocked){
						searchResult.addObject(Filmeet.User.create({
							username: friendAndBlocked.username,
							blocked: friendAndBlocked.blocked
						}));
					});
				}
			});			
			
			return searchResult;
		}
	});
});