/**
 * FriendsDirectoryRoute.
 * @author Alejandro Arnáiz González, deathnew[at]gmail.com
 * @author Diego Crenes Carrera, dcrenes[at]gmail.com
 */

define('routes/friends/friendsdirectoryroute',
		['app',
		 'utils/transitionutils',
		 'ember',
		 'views/friends/directory/friendsdirectoryview',
		 'controllers/friends/directory/friendsdirectorycontroller',
		 'models/user/user'],
		 function(Filmeet, TransitionUtils){
	Filmeet.FriendsDirectoryRoute = Ember.Route.extend({
		activate: function(){
			TransitionUtils.setContext(this);
			document.addEventListener('backbutton', TransitionUtils.goHome, false);
		},
		deactivate: function(){
			TransitionUtils.setContext(this);
			document.removeEventListener('backbutton', TransitionUtils.goHome);
		},
		setupController: function(controller, model){
			controller.set('content', Filmeet.User.getAllFriends());
		}
	});
});